SUU2B  ; suu2b/asm
 RPDIR	RST	8		;read protect directory
 	DB	10,0
 	CALL	GETDRIVES
 	LD	DE,RDPRI1
 RPDIRD	LD	BC,GOBACK
 	JP	DRVCOMM
 URPDIR	RST	8		;un-read protect dir
 	DB	10,0
 	CALL	GETDRIVES
 	LD	DE,RDPRI2
 	JR	RPDIRD
 RDPRI2	CALL	COMPDATA	;compute DATA write byte
 	JR	RPDIRC		;go common
 RDPRI1	CALL	COMPDIR		;compute DIR write byte
 RPDIRC	LD	(DDIRRS),A	;save in code for MWRITE
 	CALL	RDDIR		;read the directory
 	JR	C,DIRNOTA	;error
 	JR	Z,DIRNOTA	;not enough sectors
 	OR	A
 	CALL	GETDIR		;get directory track
 	LD	D,A		;A = total sectors
 	LD	A,(DIRCOUNT)	;get real count
 	CP	D		;enough?
 	JR	C,DIRNOTA	;go if not
 	LD	A,0
 DDIRRS	EQU	$-1
 	JP	WRDIRTT		;write directory back
 DIRNOTA	RST	8
 	DB	10,'Cannot locate Directory !',10,0
 DIRNOTB	RST	8
 	DB	1EH,'Track, Sector count ? ',0
 	LD	B,20		;20 key input
 	RST	10H
 	LD	A,17		;default track 17
 	JR	Z,DIRNOTC
 	CALL	UCASE		;make it upper case
 	CP	'S'		;same as specified?
 	RET	Z
 	CALL	VALUE		;get number
 	JR	C,DIRNOTB
 	JR	NZ,DIRNOTB
 DIRNOTC	SCF
 	CALL	GETDIR		;put in table
 	CALL	POSHL		;check for more
 	JR	C,DFFRP
 	CALL	VALUE
 	JR	C,DIRNOTB
 	JR	NZ,DIRNOTB
 DFFRPGO	LD	(DIRCOUNT),A	;directory sector count
 	LD	L,A
 	LD	H,0
 	LD	BC,GATBUFF	;start of directory
 	OR	A
 	CALL	GETDIR		;load DE with tk/sec
 	CALL	MREAD		;read the track
 	RET	NZ		;error in reading
 	LD	A,(DDIRRS)
 	JP	WRDIRTT		;write the directory
 DFFRP	CALL	TRKEND		;last sector on track
 	JR	DFFRPGO
 REPGAT	LD	HL,GATREP	;repair GAT
 	JR	REPCOMM
 REPHIT	LD	HL,HITREP	;repair HIT
 	JR	REPCOMM
 REPBOOT	LD	HL,BOOTREP	;repair BOOT
 REPCOMM	PUSH	HL
 	CALL	GETDRIVES	;ask which drives
 	POP	DE		;DE = common routine
 	LD	BC,GOBACK	;enter to continue
 	JP	DRVCOMM		;do all drives
 GATREP	CALL	RDDIR		;read a directory
 	JP	C,NOTDIR	;error
 	JP	Z,NOTDIR	;not the whole thing
 	RST	8
 	DB	10,0
 ASKGRP	RST	8
 	DB	1EH,'A>llocation table or E>ntire sector ? ',0
 	LD	B,1		;one key input
 	RST	10H
 	JR	Z,DOALLT	;all default
 	CALL	UCASE
 	CP	'A'
 	JR	Z,DOALLT
 	CP	'E'
 	JR	NZ,ASKGRP
 	CALL	INITGAT		;zero the gat
 DOALLT	CALL	MAKEGAT+3	;don't compute tracks
 	JP	WRDIR		;write the dir back
 HITREP	CALL	RDDIR		;read it in
 	JP	C,NOTDIR	;error
 	JP	Z,NOTDIR
 	CALL	FIGTRAKS	;compute tracks from gat
 	CALL	MAKEHIT		;make a hit table
 	JP	WRDIR		;write the directory
 BOOTREP	OR	A
 	CALL	GETDIR		;get directory track
 	OR	A
 	CALL	GETTYPEA
 	LD	HL,KIMBOOT+2
 	LD	BC,KIMBOOT3+2
 	BIT	2,A
 	JR	Z,PTYRR
 	DEC	HL
 	DEC	BC
 	LD	E,1
 PTYRR	BIT	1,A
 	LD	A,D
 	JR	Z,BRTP
 	SET	7,A		;set for dos+
 BRTP	LD	(HL),A		;put directory track
 	LD	(BC),A		;into both boots
 	LD	D,0
 	LD	BC,KIMBOOT	;my very own BOOT
 	CALL	COMPDATA	;compute data write
 	LD	(WRTYPE),A
 	CALL	DSTAT		;check for disk there
 	RET	NZ		;exit if not
 	RST	30H		;write the sector
 	LD	E,1
 	LD	BC,KIMBOOT3	;mod III boot
 	JP	30H		;write it out
 ZUNGRANS	CALL	GETDRIVES
 	LD	DE,ZUNGO
 	LD	BC,GOBACK
 	JP	DRVCOMM
 ZUNGO	CALL	RDDIR		;read the directory
 	JP	C,NOTDIR
 	JP	Z,NOTDIR
 	CALL	DIRPART		;show name date
 	LD	D,0		;start track 0
 	LD	IX,GATBUFF	;start of directory
 ZUNGOLP	LD	E,0
 	OR	A
 	CALL	GETTYPEA
 	BIT	2,A
 	JR	Z,ZU018
 	INC	E
 ZU018	RRC	(IX)
 	CALL	NC,ZEGRAN	;NC = unused gran
 	CALL	NEXEGRAN	;next gran
 	RRC	(IX)
 	CALL	NC,ZEGRAN
 	CALL	NEXEGRAN
 	RRC	(IX)
 	CALL	NC,ZEGRAN
 	RRC	(IX)
 	CALL	NC,ZEGRAN
 	CALL	NEXEGRAN
 	RRC	(IX)
 	CALL	NC,ZEGRAN
 	CALL	NEXEGRAN
 	RRC	(IX)
 	CALL	NC,ZEGRAN
 	INC	IX
 	INC	D
 	OR	A
 	CALL	DDOSTRACKS
 	CP	D
 	JR	NZ,ZUNGOLP
 	RET
 ZEGRAN	CALL	GRNSIZE		;# sectors per gran
 	PUSH	DE
 ZEGRAN1	PUSH	BC
 	LD	BC,BUFFER
 	CALL	ZBUFF		;zero it out
 	RST	30H		;write a sector
 	POP	BC
 	INC	E		;next sector
 	DJNZ	ZEGRAN1		;do this gran
 ZEGRAN2	POP	DE
 	RET
 GRNSIZE	OR	A
 	CALL	GETTYPEA
 	LD	B,5
 	BIT	7,A
 	RET	Z
 	BIT	4,A
 	RET	NZ
 	LD	B,6
 	BIT	2,A
 	RET	Z
 	LD	B,3
 	RET
 NEXEGRAN	CALL	GRNSIZE
 NEXEGRAN1	INC	E
 	DJNZ	NEXEGRAN1
 	RET
 CHKDIR	CALL	GETDRIVES
 	LD	DE,CKDIR0
 	LD	BC,GOBACK
 	JP	DRVCOMM
 CKDIR0	CALL	RDDIR		;read the directory
 	JP	Z,NOTDIR
 	JP	C,NOTDIR
 	CALL	DIRPART		;show name date
 	CALL	INITCOUNT	;zero the counter
 	LD	HL,GATBUFF	;start of directory
 	LD	DE,DAMBUFF	;save down here
 	LD	BC,100H		;256 bytes
 	LDIR
 	CALL	MAKEGAT		;make a GAT
 	LD	HL,GATBUFF
 	LD	DE,DAMBUFF
 	OR	A
 	CALL	DDOSTRACKS	;get relative tracks
 	LD	B,A
 	CALL	COMPARE		;check 2 tables
 	JR	Z,GTOKO		;Z = equal
 	RST	8
 	DB	10,'GAT Table is BAD !',0
 	CALL	PAUSE		;wait for pause if any
 	CALL	ADDCOUNT	;bump error counter
 GTOKO	LD	HL,GATBUFF+100H	;HIT table
 	LD	DE,DAMBUFF	;save it here
 	LD	BC,100H
 	LDIR
 	CALL	MAKEHIT		;re-assign all files
 	LD	HL,GATBUFF+100H
 	LD	DE,DAMBUFF
 	LD	A,(DAMBUFF+1)	;allow bad DIR/SYS byte
 	LD	(GATBUFF+101H),A
 	LD	B,0
 	OR	A
 	CALL	GETTYPEA
 	BIT	2,A
 	JR	Z,U874
 	LD	B,0E0H		;skip sys files trs iii
 U874	CALL	COMPARE		;see if the same?
 	JR	Z,GHTOKO	;OK if Z
 	RST	8
 	DB	10,'HIT Table is BAD !',0
 	CALL	PAUSE
 	CALL	ADDCOUNT	;another error
 GHTOKO	CALL	GETENTRIES	;get DE with # records
 	LD	IX,GATBUFF+200H
 	RST	8
 	DB	10,0
 GHTOKI	BIT	4,(IX)
 	PUSH	IX
 	PUSH	DE
 	CALL	NZ,CHKITOUT	;NZ = active record
 	POP	DE
 	POP	IX
 	CALL	IXDIR		;position to next one
 	DEC	DE
 	LD	A,D
 	OR	E
 	JR	NZ,GHTOKI	;go if more left
 	RST	8
 	DB	10,0
 	CALL	SHOCOUNT	;show counter
 	RST	8
 	DB	'Total Errors.',10,0
 	JP	PAUSE
 CHKITOUT	BIT	7,(IX)	;check if extension
 	RET	NZ		;skip if yes
 	PUSH	IX
 	POP	IY
 CHKITT	LD	B,5		;5 extents per record
 	OR	A
 	CALL	GETTYPEA
 	BIT	2,A
 	JR	Z,CURKE
 	LD	B,13		;13 for trsiii
 CURKE	LD	A,(IY+16H)
 	CP	0FFH		;terminator?
 	RET	Z		;done if yes
 	CP	0FEH		;extension?
 	JR	Z,CHKITX	;get it if yes
 	INC	IY
 	INC	IY
 	DJNZ	CURKE		;do whole record
 	LD	HL,(CURSOR)
 	CALL	SHOWIT		;show file
 	RST	8
 	DB	' Bad Extents !',10,0
 	CALL	PAUSE
 	JP	ADDCOUNT	;add error
 CHKITX	LD	A,(IY+17H)
 	AND	1FH		;sector displacement
 	LD	H,A
 	LD	A,(IY+17H)
 	AND	0E0H		;disp within sector
 	LD	L,A
 	LD	DE,GATBUFF+200H
 	ADD	HL,DE
 	BIT	4,(HL)		;see if active
 	JR	Z,BADFOR
 	BIT	7,(HL)		;see if extension
 	JR	Z,BADFOR
 	PUSH	HL		;pass to IY
 	POP	IY
 	PUSH	IX
 	POP	HL
 	LD	DE,GATBUFF+200H
 	OR	A
 	SBC	HL,DE
 	LD	A,H
 	OR	L
 	CP	(IY+1)		;see if link is OK
 	JP	Z,CHKITT
 	LD	HL,(CURSOR)
 	CALL	SHOWIT		;show name
 	RST	8
 	DB	' Bad Backward Link !',10,0
 	CALL	PAUSE
 	JP	ADDCOUNT	;add this error
 BADFOR	LD	HL,(CURSOR)
 	CALL	SHOWIT		;show filename
 	RST	8
 	DB	' Bad Forward Link !',10,0
 	CALL	PAUSE
 	JP	ADDCOUNT
 MOVEDIR	CALL	GETDRIVES
 	LD	DE,MOVEDIR0
 	LD	BC,GOBACK
 	JP	DRVCOMM
 MOVEDIR0	OR	A
 	CALL	GETTYPEA
 	BIT	5,A		;doubledos?
 	JR	Z,MOVEDIRX0X	;can't move it
 	CALL	DRVASC		;ascii drive number
 	LD	(NDRMV),A
 	RST	8
 	DB	10,'Cannot move DoubleDOS directory on Drive '
 NDRMV	DB	'x !',10,0
 	RET
 MOVEDIRX0X	CALL	RDDIR	;read the directory
 	JP	Z,NOTDIR
 	JP	C,NOTDIR
 	CALL	DIRPART		;show name date
 	RST	8
 	DB	10,0
 MOVEDIR1	RST	8
 	DB	1EH,'Move to track ? ',0
 	LD	B,20
 	RST	10H
 	RET	Z		;nill input
 	CALL	VALUE		;get where
 	JR	C,MOVEDIR1	;invalid number
 	JR	NZ,MOVEDIR1	;too big
 	LD	HL,GATBUFF
 	ADD	HL,BC		;point to desired track
 	OR	A
 	CALL	GETDIR
 	LD	A,D
 	CP	C
 	JP	Z,MOVEDIR3	;already on that track
 	LD	A,(HL)
 	INC	A
 	JP	Z,MOVEDIR2	;track assigned already
 	PUSH	HL
 	PUSH	BC		;save 'em
 	OR	A
 	CALL	GETDIR
 	LD	HL,GATBUFF
 	LD	L,D
 	CALL	MANYGRANS	;how many grans/track
 	LD	(HL),E		;result
 	LD	A,(DIRCOUNT)	;# dir sectors
 	LD	HL,FBUFF	;format buffer
 	PUSH	HL
 	LD	DE,FBUFF+1
 	LD	BC,4000H
 	LD	(HL),0		;clear it out
 	DI
 	LDIR
 	EI
 	POP	BC
 	LD	L,A
 	LD	H,0
 	OR	A
 	CALL	GETDIR
 	EXX
 	LD	HL,DAMBUFF
 	LD	DE,DAMBUFF+1
 	CALL	COMPDATA
 	LD	(HL),A
 HGKW	LD	BC,0FFH
 	LDIR
 	EXX
 	CALL	MWRITE		;multiple write
 	POP	BC
 	POP	HL
 	RET	NZ
 	LD	(HL),0FFH	;allocate new dir
 	LD	A,C
 	SCF
 	PUSH	AF
 	CALL	GETDIR
 	LD	A,C
 	LD	(GATBUFF+316H),A	;put into DIR/SYS
 	EXX
 	LD	HL,DAMBUFF
 	LD	DE,DAMBUFF+1
 	LD	BC,0FFH
 	CALL	COMPDIR
 	LD	(HL),A
 	LDIR
 	EXX
 	CALL	WRDIR		;write the directory
 	LD	DE,0
 	OR	A
 	CALL	GETTYPEA
 	BIT	2,A
 	JR	Z,DOHR4
 	LD	E,1
 DOHR4	LD	BC,BUFFER
 	RST	28H		;read the boot
 	POP	AF
 	PUSH	AF
 	LD	HL,BUFFER+1
 	LD	C,A
 	OR	A
 	CALL	GETTYPEA
 	BIT	2,A
 	LD	A,C
 	JR	NZ,DOXR
 	INC	HL
 DOXR	LD	(HL),A		;put new dir location
 	PUSH	HL
 	LD	BC,BUFFER
 	CALL	COMPDATA
 	LD	(WRTYPE),A
 	JP	30H		;write boot back
 MOVEDIR2	RST	8
 	DB	10,'Track Allocated !',10,0
 	JP	MOVEDIR1
 MOVEDIR3	RST	8
 	DB	10,'Directory there !',10,0
 	JP	MOVEDIR1
 MANYGRANS	OR	A
 	CALL	GETTYPEA
 	BIT	7,A
 	LD	E,0FCH		;empty byte
 	RET	Z
 	BIT	4,A
 	RET	NZ
 	LD	E,0F8H		;double density
 	BIT	2,A
 	RET	Z
 	LD	A,0C0H		;empty trs iii
 	RET

 	JP	MOVEDIR1
 MANYGRANS	OR	A
 	CALL	GETTYPEA
 	BIT	7,A
 	LD	E,0FCH		;empty byte
 	RET	Z
 	BIT	4,A
 	RET	NZ
 	LD	E,0F8H		;double density
 	BIT	2,A
 	RET	Z
 	LD	A,0C0H		;